image: maven:3.8.6-eclipse-temurin-17

before_script:

  - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
  #- apk update && apk add bash
  - apt-get update -y && apt-get install gettext-base -y
  - apt-get install zip unzip
  - java -version
  - apt-get -yq update
  - apt-get -yq install software-properties-common
  - add-apt-repository universe
  - apt-get -yq install software-properties-common
  - add-apt-repository -y ppa:deadsnakes/ppa
  - apt-get -yq update


  - apt-get -qq update && apt-get -qq install -y python
  - apt-get -qq update
  - apt-get -qq install -y python python-virtualenv python-pip
  - virtualenv venv
  - . venv/bin/activate
  - python -V
  - pip install pandas

variables:
  IS_DEV_BUILD:
    value: "True"
    options:
      - "True"
      - "False"
    description: "True: build & deploy as nightly. False: build and deploy as release."

stages:
  - build
  - installer
  - deploy
  - notify

workflow:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
      when: always
    - if: '$CI_PROJECT_NAMESPACE != "xvm"'
      when: never
    - if: '$CI_COMMIT_TAG != null'
      when: never
    - if: '$CI_COMMIT_MESSAGE =~ /\[no-ci\]/'
      when: never
    - when: always

build-lesta:
  stage: build
  script:
    - XVMBUILD_FLAVOR="lesta" ./build.sh
  artifacts:
    paths:
      - ~output/lesta/deploy/
    expire_in: 1 day

build-wg:
  stage: build
  script:
    - XVMBUILD_FLAVOR="wg" ./build.sh
  artifacts:
    paths:
      - ~output/wg/deploy/
    expire_in: 1 day

installer:
  stage: installer
  script:
    - ./src/installer/build.sh
  needs:
    - job: build-lesta
      artifacts: true
    - job: build-wg
      artifacts: true
  artifacts:
    paths:
      - ~output/installer/
    expire_in: 1 day

deploy:
  stage: deploy
  script:
    - ./build/ci_deploy.sh
  needs:
    - job: build-lesta
      artifacts: true
    - job: build-wg
      artifacts: true
    - job: installer
      artifacts: true
  rules:
    - if: '$CI_PIPELINE_SOURCE != "push" && $CI_PIPELINE_SOURCE != "web" && $CI_PIPELINE_SOURCE != "api"'
      when: never
    - if: $CI_COMMIT_MESSAGE =~ /\[no-deploy\]/
      when: never
    - when: on_success

notify-krcm:
  stage: notify
  script:
    - ./build/ci_notify_krcm.sh
  rules:
    - if: '$CI_PIPELINE_SOURCE != "push"'
      when: never
    - if: $CI_COMMIT_MESSAGE =~ /\[no-deploy\]/
      when: never
    - if: $CI_COMMIT_MESSAGE =~ /\[no-notify\]/
      when: never
    - if: $CI_COMMIT_MESSAGE =~ /\[no-krcm\]/
      when: never
    - when: on_success

notify-telegram:
  stage: notify
  script:
    - ./build/ci_notify_telegram.sh
  rules:
    - if: '$CI_PIPELINE_SOURCE != "push"'
      when: never
    - if: $CI_COMMIT_MESSAGE =~ /\[no-deploy\]/
      when: never
    - if: $CI_COMMIT_MESSAGE =~ /\[no-notify\]/
      when: never
    - when: on_success
